# -*- coding: utf-8 -*-

"""
bandwidth

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""


class BandwidthMessageItem(object):

    """Implementation of the 'BandwidthMessageItem' model.

    TODO: type model description here.

    Attributes:
        message_id (string): The message id
        account_id (string): The account id of the message
        source_tn (string): The source phone number of the message
        destination_tn (string): The recipient phone number of the message
        message_status (string): The status of the message
        message_direction (string): The direction of the message relative to
            Bandwidth. INBOUND or OUTBOUND
        message_type (string): The type of message. sms or mms
        segment_count (int): The number of segments the message was sent as
        error_code (int): The numeric error code of the message
        receive_time (string): The ISO 8601 datetime of the message
        carrier_name (string): The name of the carrier. Not currently
            supported for MMS, coming soon
        message_size (int): The size of the message including message content
            and headers
        message_length (int): The length of the message content
        attachment_count (int): The number of attachments the message has
        recipient_count (int): The number of recipients the message has
        campaign_class (string): The campaign class of the message, if it has
            one

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "message_id": 'messageId',
        "account_id": 'accountId',
        "source_tn": 'sourceTn',
        "destination_tn": 'destinationTn',
        "message_status": 'messageStatus',
        "message_direction": 'messageDirection',
        "message_type": 'messageType',
        "segment_count": 'segmentCount',
        "error_code": 'errorCode',
        "receive_time": 'receiveTime',
        "carrier_name": 'carrierName',
        "message_size": 'messageSize',
        "message_length": 'messageLength',
        "attachment_count": 'attachmentCount',
        "recipient_count": 'recipientCount',
        "campaign_class": 'campaignClass'
    }

    def __init__(self,
                 message_id=None,
                 account_id=None,
                 source_tn=None,
                 destination_tn=None,
                 message_status=None,
                 message_direction=None,
                 message_type=None,
                 segment_count=None,
                 error_code=None,
                 receive_time=None,
                 carrier_name=None,
                 message_size=None,
                 message_length=None,
                 attachment_count=None,
                 recipient_count=None,
                 campaign_class=None):
        """Constructor for the BandwidthMessageItem class"""

        # Initialize members of the class
        self.message_id = message_id
        self.account_id = account_id
        self.source_tn = source_tn
        self.destination_tn = destination_tn
        self.message_status = message_status
        self.message_direction = message_direction
        self.message_type = message_type
        self.segment_count = segment_count
        self.error_code = error_code
        self.receive_time = receive_time
        self.carrier_name = carrier_name
        self.message_size = message_size
        self.message_length = message_length
        self.attachment_count = attachment_count
        self.recipient_count = recipient_count
        self.campaign_class = campaign_class

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary
        message_id = dictionary.get('messageId')
        account_id = dictionary.get('accountId')
        source_tn = dictionary.get('sourceTn')
        destination_tn = dictionary.get('destinationTn')
        message_status = dictionary.get('messageStatus')
        message_direction = dictionary.get('messageDirection')
        message_type = dictionary.get('messageType')
        segment_count = dictionary.get('segmentCount')
        error_code = dictionary.get('errorCode')
        receive_time = dictionary.get('receiveTime')
        carrier_name = dictionary.get('carrierName')
        message_size = dictionary.get('messageSize')
        message_length = dictionary.get('messageLength')
        attachment_count = dictionary.get('attachmentCount')
        recipient_count = dictionary.get('recipientCount')
        campaign_class = dictionary.get('campaignClass')

        # Return an object of this model
        return cls(message_id,
                   account_id,
                   source_tn,
                   destination_tn,
                   message_status,
                   message_direction,
                   message_type,
                   segment_count,
                   error_code,
                   receive_time,
                   carrier_name,
                   message_size,
                   message_length,
                   attachment_count,
                   recipient_count,
                   campaign_class)
